unit sonoraMat;

interface
uses
    windows,
    dvcrt,
    dvwin,
    dvinet,
    dvexec;

procedure abreSintMat;
procedure sintMat (faltaFalar: string);

var sock: integer = 0;

implementation

procedure abreSintMat;
begin
    abreWinSock;
    sock := abreConexao ('localhost', 51956);
    if sock > 0 then
        sintetiza ('Sonoramat ativado')
    else
        if executaProgEx('\winvox\smserver.exe', '.', '', SW_MINIMIZE) > 32 then
            abreSintMat
        else
            sintetiza ('Sonoramat no foi ativado.  Atualize o Edivox.');
end;

procedure sintMat (faltaFalar: string);
var p: integer;
    afalar, textoMat, traduzido: string;

begin
    if sock <= 0 then
        begin
            sintetiza (faltaFalar);
            exit;
        end;

    afalar := '';
    repeat
         p := pos ('`', faltaFalar);
         if p > 0 then
             begin
                 afalar := afalar + ' ' + copy (faltaFalar,1,p-1);
                 delete (faltaFalar, 1, p);

                 p := pos ('`', faltaFalar);
                 if p = 0 then
                     p := length(faltaFalar)+1;
                 textoMat := copy (faltaFalar,1, p-1);
                 delete (faltaFalar, 1, p);

                 if textoMat <> '' then
                     begin
                         writeRede(sock, '`' + textoMat + '`');
                         traduzido := readlnRede(sock);
                         afalar := afalar + ' ' + traduzido;
                     end;
             end
         else
             begin
                 afalar := afalar + ' ' + faltaFalar;
                 faltaFalar := '';
             end;

     until faltaFalar = '';

    sintetiza (afalar);
end;

end.
